(* XDS Example Application - Euroconverter *)
(* Copyright (c) 1999 Paul Floyd           *)
<*+ MAIN *>
MODULE euroconverter;
IMPORT OS2 (* imports from "os2.h" *), euro (* defines for constants *), SYSTEM, RealStr (* Modula-2 string routines *);

VAR
   (* the standard bits and pieces required to build a PM window *)
   hAB: OS2.HAB;
   hMQ: OS2.HMQ;
   hWndClient, hWndFrame: OS2.HWND;
   hSwitch: OS2.HSWITCH;
   swctl: OS2.SWCNTRL;
   AppName: ARRAY 15 OF CHAR;
   (* handles for all of the windows we'll create  *)
   groupbox, ddl, radio1, radio2, pushbutton, statictext, entryfield: OS2.HWND;
   (* Array of all the fixed Euro conversion factors *)
   ConversionFactors : ARRAY 11 OF REAL;

(* Dialog procedure for About... dialog box *)
PROCEDURE [OS2.EXPENTRY] AboutBox(hWnd: OS2.HWND; msg: OS2.ULONG; mp1, mp2: OS2.MPARAM) : OS2.MRESULT;
BEGIN
   CASE msg OF
      OS2.WM_COMMAND :
         IF ((OS2.SHORT1FROMMP(mp1) = OS2.DID_OK) OR (OS2.SHORT1FROMMP(mp1) = OS2.DID_CANCEL))
         THEN
            OS2.WinDismissDlg(hWnd, OS2.SHORT1FROMMP(mp1))
         END
      ELSE
         RETURN OS2.WinDefDlgProc(hWnd, msg, mp1, mp2)
   END;
   RETURN NIL
END AboutBox;

(* Window procedure for the main window of the application *)
PROCEDURE [OS2.EXPENTRY] MainWindow(hWnd: OS2.HWND; msg: OS2.ULONG; mp1, mp2: OS2.MPARAM) : OS2.MRESULT;
VAR
   hPS: OS2.HPS;
   rc: OS2.RECTL;
   pt: OS2.POINTL;
   (* string for the names of the currencies *)
   DDLItem : ARRAY 30 OF CHAR;
   (* string for the sum to convert to or from Euros *)
   SumToConvert : ARRAY 20 OF CHAR;
   (* result of the conversion, this is a Module-2 RECORD *)
   res : RealStr.ConvResults;
   (* Floating point representation of the value *)
   RealSum : REAL;
	Result : OS2.MRESULT;
   Index : LONGINT;
BEGIN (* MainWindow *)
   CASE msg OF
      OS2.WM_COMMAND :
         CASE OS2.SHORT1FROMMP(mp2) OF
            OS2.CMDSRC_MENU :
               CASE OS2.SHORT1FROMMP(mp1) OF
                  euro.ID_EXIT :
                     OS2.WinPostMsg(hWndFrame, OS2.WM_SYSCOMMAND, 08004H, 08004H)
                  | euro.ID_ABOUT :
                     OS2.WinDlgBox(OS2.HWND_DESKTOP, hWndFrame, AboutBox, 0, euro.ID_ABOUT, NIL)
               END
            | OS2.CMDSRC_PUSHBUTTON :
               (* User has clicked on the "Convert" pushbutton -> do the conversion *)
               (* Read the value in the entry field as a string *)
               OS2.WinQueryWindowText(entryfield, 19, SumToConvert);
               (* Convert the string to a REAL *)
               RealStr.StrToReal(SumToConvert, RealSum, res);
               (* Find the currency currently selected in the dropdown list *)
					Result := OS2.WinSendMsg(ddl, OS2.LM_QUERYSELECTION, OS2.MPFROMLONG(OS2.LIT_FIRST), NIL);
           		Index := OS2.LONGFROMMR(Result);
               (* Find out if we're converting to or from Euros *)
					Result := OS2.WinSendMsg(radio1, OS2.BM_QUERYCHECKINDEX, NIL, NIL);
               (* divide or multiply, depending on conversion direction *)
               IF OS2.SHORT1FROMMR(Result) = 0 THEN
                  RealSum := RealSum / ConversionFactors[Index]
               ELSE
                  RealSum := RealSum * ConversionFactors[Index]
               END; (* endif *)
               (* Convert the result back into a string *)
               RealStr.RealToStr(RealSum, SumToConvert);
               (* Null terminate the string - could do better here by stripping trailing zeros *)
               SumToConvert[19] := 00X;
               (* Write the string to a static text *)
               OS2.WinSetWindowText(statictext, SumToConvert);
               (* Put the focus back in the entryfield *)
               OS2.WinSetFocus(OS2.HWND_DESKTOP, entryfield)
            END (* endcase *)
      | OS2.WM_PAINT :
         hPS := OS2.WinBeginPaint(hWnd, 0, rc);
         OS2.WinFillRect(hPS, rc, OS2.CLR_WHITE);
         pt.x := 10;
         pt.y := 10;
         OS2.GpiCharStringAt(hPS, pt, 30, "Euro Converter PM application.");
         OS2.WinEndPaint(hPS)
      | OS2.WM_CLOSE :
         IF OS2.WinMessageBox(OS2.HWND_DESKTOP, hWnd,
                       "Do you really want to exit?",
                       AppName, 0,
                       OS2.MB_MOVEABLE + OS2.MB_YESNO + OS2.MB_ICONQUESTION + OS2.MB_DEFBUTTON2) # OS2.MBID_NO THEN
            OS2.WinPostMsg(hWnd, OS2.WM_QUIT, 08002H, 08002H)
         END (* endif *)
      | OS2.WM_CREATE :
         (* 2 radio buttons for To Euros and From Euros *)
         (* 1 pushbutton "do conversion: *)
         (* 1 read/write entry field (to enter the sum) - perhaps 1 to start with *)
         (* 1 static text (output of the conversion) *)
         (* 1 dropdown list combobox (for different currencies) *)
         ddl := OS2.WinCreateWindow(hWnd, OS2.WC_COMBOBOX, "", OS2.CBS_DROPDOWNLIST, 100, 325, 200, 100, hWnd, OS2.HWND_TOP, euro.ID_DDL, (* control data *) NIL, (* Pres params *) NIL);
         (* Here, intended to use OS2.WinInsertLboxItem, but the macro does not exist for Oberon *)
         (* so am using WinSendMessage, but the last parameter is a pointer to a string *)
         (* but I can't use the macro MPFROMP either *)
         COPY("Franc Francais", DDLItem);
         OS2.WinSendMsg(ddl, OS2.LM_INSERTITEM, OS2.MPFROMLONG(OS2.LIT_END), DDLItem);
         COPY("Deutschmark", DDLItem);
         OS2.WinSendMsg(ddl, OS2.LM_INSERTITEM, OS2.MPFROMLONG(OS2.LIT_END), DDLItem);
         COPY("Finnmark", DDLItem);
         OS2.WinSendMsg(ddl, OS2.LM_INSERTITEM, OS2.MPFROMLONG(OS2.LIT_END), DDLItem);
         COPY("Peseta", DDLItem);
         OS2.WinSendMsg(ddl, OS2.LM_INSERTITEM, OS2.MPFROMLONG(OS2.LIT_END), DDLItem);
         COPY("Schilling", DDLItem);
         OS2.WinSendMsg(ddl, OS2.LM_INSERTITEM, OS2.MPFROMLONG(OS2.LIT_END), DDLItem);
         COPY("Escudo", DDLItem);
         OS2.WinSendMsg(ddl, OS2.LM_INSERTITEM, OS2.MPFROMLONG(OS2.LIT_END), DDLItem);
         COPY("Guilder", DDLItem);
         OS2.WinSendMsg(ddl, OS2.LM_INSERTITEM, OS2.MPFROMLONG(OS2.LIT_END), DDLItem);
         COPY("Franc Lux", DDLItem);
         OS2.WinSendMsg(ddl, OS2.LM_INSERTITEM, OS2.MPFROMLONG(OS2.LIT_END), DDLItem);
         COPY("Franc Belge", DDLItem);
         OS2.WinSendMsg(ddl, OS2.LM_INSERTITEM, OS2.MPFROMLONG(OS2.LIT_END), DDLItem);
         COPY("Punt", DDLItem);
         OS2.WinSendMsg(ddl, OS2.LM_INSERTITEM, OS2.MPFROMLONG(OS2.LIT_END), DDLItem);
         COPY("Lire", DDLItem);
         OS2.WinSendMsg(ddl, OS2.LM_INSERTITEM, OS2.MPFROMLONG(OS2.LIT_END), DDLItem);
         (* select the first oitem in the list (item 0) *)
         OS2.WinSendMsg(ddl, OS2.LM_SELECTITEM, OS2.MPFROMSHORT(0), OS2.MPFROMSHORT(1));
         OS2.WinShowWindow(ddl, TRUE);

         groupbox := OS2.WinCreateWindow(hWnd, OS2.WC_STATIC, "Direction", OS2.SS_GROUPBOX, 325, 375, 100, 70, hWnd, OS2.HWND_TOP, euro.ID_TOFROMGROUP, (* control data *) NIL, (* Pres params *) NIL);
         OS2.WinShowWindow(groupbox, TRUE);

         (* Auto radio button #1, this one is checked by default *)
         radio1 := OS2.WinCreateWindow(hWnd, OS2.WC_BUTTON, "To ", OS2.BS_AUTORADIOBUTTON + OS2.WS_GROUP, 330, 380, 60, 15, groupbox, OS2.HWND_TOP, euro.ID_TO, (* control data *) NIL, (* Pres params *) NIL);
         OS2.WinSendMsg(radio1, OS2.BM_SETCHECK, OS2.MPFROMSHORT(1), NIL);
         OS2.WinShowWindow(radio1, TRUE);

         (* Auto radio button #2, sibling of #1 *)
         radio2 := OS2.WinCreateWindow(hWnd, OS2.WC_BUTTON, "From ", OS2.BS_AUTORADIOBUTTON, 330, 400, 80, 15, groupbox, radio1, euro.ID_FROM, (* control data *) NIL, (* Pres params *) NIL);
         OS2.WinShowWindow(radio2, TRUE);

         pushbutton := OS2.WinCreateWindow(hWnd, OS2.WC_BUTTON, "Convert", OS2.WS_VISIBLE + OS2.BS_PUSHBUTTON + OS2.BS_DEFAULT, 100, 100, 100, 50, hWnd, OS2.HWND_TOP, euro.ID_BUTTON, NIL, NIL );
         statictext := OS2.WinCreateWindow(hWnd, OS2.WC_STATIC, "static", OS2.WS_VISIBLE + OS2.SS_TEXT, 100, 250, 400, 20, hWnd, OS2.HWND_TOP, euro.ID_STATIC, NIL, NIL);
         entryfield := OS2.WinCreateWindow(hWnd, OS2.WC_ENTRYFIELD, "", OS2.WS_VISIBLE + OS2.ES_MARGIN, 100, 300, 400, 20, hWnd, OS2.HWND_TOP, euro.ID_ENTRY, NIL, NIL);
                        OS2.WinSetWindowText(entryfield, "1");
         OS2.WinSetFocus(OS2.HWND_DESKTOP, entryfield);
   ELSE
      RETURN OS2.WinDefWindowProc(hWnd, msg, mp1, mp2)
   END; (* endcase *)

  RETURN NIL
END MainWindow;

PROCEDURE MyMain();
   VAR
      qmsg: OS2.QMSG;
      flCreate: OS2.ULONG;
BEGIN (* main *)

   (* standard initialization of a PM application *)
   hAB := OS2.WinInitialize(0);
   hMQ := OS2.WinCreateMsgQueue(hAB, 0);

   OS2.WinRegisterClass(hAB, AppName, MainWindow, OS2.CS_SIZEREDRAW, 0);

   flCreate := OS2.FCF_STANDARD;

   hWndFrame := OS2.WinCreateStdWindow(OS2.HWND_DESKTOP, 0, flCreate,
    AppName, "", 0, 0, euro.ID_WINDOW, hWndClient);

   OS2.WinSetWindowText(OS2.WinWindowFromID(hWndFrame, OS2.FID_TITLEBAR), AppName);
   OS2.WinSetWindowPos(hWndFrame, 0, 0, 0, 0, 0, OS2.SWP_ACTIVATE + OS2.SWP_SHOW);
   hSwitch := OS2.WinQuerySwitchHandle(hWndFrame, 0);
   OS2.WinQuerySwitchEntry(hSwitch, swctl);
   COPY(AppName, swctl.szSwtitle);
   OS2.WinChangeSwitchEntry(hSwitch, swctl);

   WHILE OS2.WinGetMsg(hAB, qmsg, 0, 0, 0) DO
      OS2.WinDispatchMsg(hAB, qmsg);
   END; (* endwhile *)

   OS2.WinDestroyWindow(hWndFrame);

   OS2.WinDestroyMsgQueue(hMQ);
   OS2.WinTerminate(hAB);

  RETURN
END MyMain;

BEGIN
   (* main *)
   COPY("Euro Converter", AppName);
   AppName[14] := 00X;
   (* Setup the array of factors *)
	ConversionFactors[0] := 6.55957; (* FFR *)
   ConversionFactors[1] := 1.95583; (* DEM *)
   ConversionFactors[2] := 5.94573; (* FIM *)
   ConversionFactors[3] := 166.386; (* ESP *)
   ConversionFactors[4] := 13.7603; (* ATS *)
   ConversionFactors[5] := 200.482; (* ESC *)
   ConversionFactors[6] := 2.20371; (* NLG *)
   ConversionFactors[7] := 40.3399; (* BEF*)
   ConversionFactors[8] := 40.3399; (* LUF *)
   ConversionFactors[9] := 0.78756; (* IEP *)
   ConversionFactors[10] := 1936.27; (* ITL *)
   (* call the procedure that does all the work *)
   MyMain
END euroconverter.
