(* XDS Example Application - prime *)
(* Copyright (c) 1999 Paul Floyd *)
<*+ MAIN *>
MODULE prime;
IMPORT SWholeIO, InOut;
CONST
   limit = 2000; (* array to store the prime numbers *)
VAR
   Prime: ARRAY limit+1 OF INTEGER;
   n, j, k, r, q: INTEGER; (* n potential primes *)
                           (*  j count of primes found so far *)
                           (*  k index for testing *)
                           (*  r remainder *)
                           (* q quotient *)

(* See Knuth "The Art of Computer Programming" Vol. 1 P. 147 for a description of this algorithm *)
BEGIN
   (* main *)
   n := 3;
   j := 1;
   Prime[j] := 2;

   WHILE j <= limit-1 DO
      INC(j);
      Prime[j] := n;
      n := n + 2;
      k := 2;
      q := n DIV Prime[k];
      r := n MOD Prime[k];
      LOOP
         IF r = 0 THEN
            (* remainder zero - not prime *)
            n := n + 2;
            k := 2;
            q := n DIV Prime[k];
            r := n MOD Prime[k]
         ELSE
            IF q <= Prime[k] THEN
               (* found prime *)
               EXIT
            ELSE
               (* keep dividing by already-found primes in array *)
               INC(k);
               q := n DIV Prime[k];
               r := n MOD Prime[k]
            END (* endif *)
         END (* endif *)
      END (* loop *)
   END; (* endwhile *)

   (* print out the array *)
   FOR j := 1 TO limit DO
      InOut.WriteString("Prime number");
      SWholeIO.WriteInt(j, 0);
      InOut.WriteString(" is");
      SWholeIO.WriteInt(Prime[j], 0);
      InOut.WriteLn
   END; (* endfor *)
END prime.
